#!/usr/bin/env python3
# encoding: utf-8
#
# ** header v3.0
# This file is a part of the CaosDB Project.
#
# Copyright (C) 2021 Indiscale GmbH <info@indiscale.com>
# Copyright (C) 2021 Henrik tom Wörden <h.tomwoerden@indiscale.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
#
# ** end header
#

"""
test identified_cache module
"""

import caosdb as db
from caoscrawler.identifiable import Identifiable
from caoscrawler.identified_cache import IdentifiedCache


def test_IdentifiedCache():
    ident = Identifiable(name="A", record_type="B")
    record = db.Record("A").add_parent("B").add_property('b', 5)
    cache = IdentifiedCache()
    assert ident not in cache
    cache.add(record=record, identifiable=ident)
    assert ident in cache
    assert cache[ident] is record
    assert Identifiable(name="A", record_type="C") != Identifiable(name="A", record_type="B")
    assert Identifiable(name="A", record_type="C") not in cache
